/************ 
 * 
 * yuv_4XX_to_RGB_shader.fs 
 * 
 *  It is a YUV 4XX to RGB conversion shader
 *   Outputs to a window
 * 
 */
uniform sampler2DRect Ytex;
uniform sampler2DRect Utex;
uniform sampler2DRect Vtex;
uniform float         XFormat ; // 2 if 4:2:x format, 1 if 4:4:4 
uniform float         YFormat ; // 2 if 4:2:0 format, 1 if 4:4:4 or 4:2:2

void main(void) 
{
float r, g, b, y, u, v ;

y  = texture2DRect(Ytex,vec2(gl_TexCoord[0].x,           gl_TexCoord[0].y)).r;
u  = texture2DRect(Utex,vec2(gl_TexCoord[0].x / XFormat, gl_TexCoord[0].y / YFormat)).r;
v  = texture2DRect(Vtex,vec2(gl_TexCoord[0].x / XFormat, gl_TexCoord[0].y / YFormat)).r;

y  = 1.1643 * (y - 0.0625) ;
u  = u - 0.5 ;
v  = v - 0.5 ;

r  = y + 1.5958  * v ;
g  = y - 0.39173 * u - 0.81290 * v ;
b  = y + 2.017   * u ;

gl_FragColor = vec4(r,g,b,1.0) ; 
}
